# $Id: ed.bzl,v 1.1 2018/08/12 18:11:38 aehlig Exp $
def _ed_impl(ctx):
  args = [f.path for f in ctx.files.src] \
    + [f.path for f in ctx.files.script] \
    + [ctx.outputs.out.path]
  ctx.actions.run(
    inputs = depset(transitive = [depset(ctx.files.src),
                                  depset(ctx.files.script),
                                  depset(ctx.files._call_ed)]),
    outputs = [ctx.outputs.out],
    executable = ctx.files._call_ed[0],
    arguments = args,
    use_default_shell_env = True,
    mnemonic = "EdTransformation",
    progress_message = "Editing %s" % ctx.label,
  )

ed = rule(
  implementation = _ed_impl,
  attrs = {
    "src" : attr.label(allow_files=True),
    "script" : attr.label(allow_files=True),
    "out" : attr.output(),
    "_call_ed" : attr.label(
      cfg="host", allow_files=True,
      default = Label("//aehlig_rules/textproc/ed:call_ed")),
  },
)
